*  .. 2001, piva@kurgan.isp.ru
*
*    TaskBar
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* 
*    
* 0    
*   	1 - AutoHide (ABS_AUTOHIDE)
* 				2 - Always On Top    (ABS_ALWAYSONTOP)
*
*  -  1,2,3,4
*   TaskBar -    
* 1 -   
* 2 -   
* 3 -   
* 4 -   
*  
* :    TaskBar  ,
*    -2
*   Top=-2, Left=-2

* -    EDGE ()  API
*
* 5 -     
*  
*	LEFT=0		(ABE_LEFT)
*	TOP=1		(ABE_TOP)
*	RIGHT=2		(ABE_RIGHT)
*	BOTTOM=3	(ABE_BOTTOM)
*
* E BOTTOM < SYSTEMTRICT(2) - 
*  RIGHT < SYSMETRIC(1) - 
* E LEFT > 0 - 
*  Top > 0 - 
*


*[CUT FROM shellapi.h]
*////
*//// AppBar stuff
*////
#define ABM_NEW				0x00000000
#define ABM_REMOVE			0x00000001
#define ABM_QUERYPOS		0x00000002
#define ABM_SETPOS			0x00000003
#define ABM_GETSTATE		0x00000004
#define ABM_GETTASKBARPOS	0x00000005
#define ABM_ACTIVATE		0x00000006
#define ABM_GETAUTOHIDEBAR	0x00000007
#define ABM_SETAUTOHIDEBAR	0x00000008
                                        
#define ABM_WINDOWPOSCHANGED 0x0000009

*// these are put in the wparam of callback messages
#define ABN_STATECHANGE     0x0000000
#define ABN_POSCHANGED      0x0000001
#define ABN_FULLSCREENAPP   0x0000002
#define ABN_WINDOWARRANGE   0x0000003

*// flags for get state
#define ABS_AUTOHIDE    	0x0000001
#define ABS_ALWAYSONTOP 	0x0000002

#define ABE_LEFT        0
#define ABE_TOP         1
#define ABE_RIGHT       2
#define ABE_BOTTOM      3
*[End CUT]

lparameter m.DataType

if vartype(m.DataType) # 'N'
	m.DataType=0
endif

declare integer SHAppBarMessage in shell32.dll ;
	integer Message, string @ struct

local buf
buf=chr(32)+repl(chr(0),32)

do case
case m.DataType=0
	Return ShAppBarMessage(4,@buf)
case inlist(m.DataType,1,2,3,4)
	if  SHAppBarMessage(5,@buf) = 1
		do case
		case m.DataType=1	&& Left
			Return C2B(SubStr(buf,17,4))
		case m.DataType=2	&& Top
			Return C2B(SubStr(buf,21,4))
		case m.DataType=3	&& Right
			Return C2B(SubStr(buf,25,4))
		case m.DataType=4	&& Bottom
			Return C2B(SubStr(buf,29,4))
		endcase
	endif
case m.DataType=5
	if  SHAppBarMessage(5,@buf) = 1
		do case
		case C2B(SubStr(buf,29,4)) < SYSMETRIC(2)
			Return ABE_TOP
		case C2B(SubStr(buf,25,4)) < SYSMETRIC(1)
			Return ABE_LEFT
		case C2B(SubStr(buf,17,4)) > 0
			Return ABE_RIGHT
		case C2B(SubStr(buf,21,4)) > 0
			Return ABE_BOTTOM
		endcase
	endif
endcase
Return 0

Procedure C2B( string )
*        CTOBIN ?
local ret, i
ret=0
for i=len(string) to 1 step -1
	ret=asc(substr(string,i,1))+BitLShift(ret,8)
next
Return Int(Ret)
